package plp.imperative1.declaration;

import plp.imperative1.memory.AmbienteExecucaoImperativa;
import plp.imperative1.memory.AmbienteCompilacaoImperativa;
import plp.imperative1.memory.EntradaVaziaException;
import plp.expressions2.memory.IdentificadorJaDeclaradoException;
import plp.expressions2.memory.IdentificadorNaoDeclaradoException;

public abstract class Declaracao<T, E> {
	
	protected T parametro1;
    protected E parametro2;

	public Declaracao(T declaracao1, E declaracao2) {
        this.parametro1 = declaracao1;
        this.parametro2 = declaracao2;
    }
	
    public abstract AmbienteExecucaoImperativa elabora(AmbienteExecucaoImperativa ambiente)
        throws IdentificadorJaDeclaradoException, IdentificadorNaoDeclaradoException,
			EntradaVaziaException;

    public abstract boolean checaTipo(AmbienteCompilacaoImperativa ambiente)
    	throws IdentificadorJaDeclaradoException, IdentificadorNaoDeclaradoException,
			EntradaVaziaException;
}
