package plp.orientadaObjetos1.agente;

import plp.orientadaObjetos1.expressao.leftExpression.Id;

/**
 * 
 * Casse que representa a declarao de uma base de regras
 *
 */
public class BaseDeRegras {
	
	private Id nomeBase; // Identificador com o nome da base
	
	private DecRegras regras; // Declarao das regras
	
	/**
	 * Construtor com os atributos da classe
	 * 
	 * @param nomeBase O nome da base
	 * @param regras   As regras que compoem a base
	 */
	public BaseDeRegras(Id nomeBase, DecRegras regras) {
		this.nomeBase = nomeBase;
		this.regras = regras;
	}

	/**
	 * Retorna o nome da base
	 * 
	 * @return Retorna o nome da base
	 */
	public Id getNomeBase() {
		return nomeBase;
	}

	/**
	 * Retorna a base de regras
	 * 
	 * @return Retorna a base de regras
	 */
	public DecRegras getRegras() {
		return regras;
	}
}
