package plp.orientadaObjetos1.agente;

import plp.expressions2.memory.VariavelJaDeclaradaException;
import plp.expressions2.memory.VariavelNaoDeclaradaException;
import plp.orientadaObjetos1.declaracao.elemento.DecElementoSimples;
import plp.orientadaObjetos1.declaracao.procedimento.DecProcedimento;
import plp.orientadaObjetos1.excecao.declaracao.ElementoJaDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ElementoNaoDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ProcedimentoJaDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ProcedimentoNaoDeclaradoException;
import plp.orientadaObjetos1.expressao.leftExpression.Id;
import plp.orientadaObjetos1.memoria.AmbienteCompilacaoOO1;
import plp.orientadaObjetos1.memoria.AmbienteExecucaoOO1;
import plp.orientadaObjetos1.memoria.DefAgente;

public class DecAgenteAtomica extends DecElementoSimples {

	private DecBaseDeRegras baseDeRegras; // As regras do agente

	/**
	 * Construtor com os parmestro da classe e da super classe
	 * 
	 * @param nomeAgente   O nome do agente
	 * @param baseDeRegras A base de regras
	 * @param metodos      O mtodos do agente
	 */
	public DecAgenteAtomica(Id nomeAgente, DecBaseDeRegras baseDeRegras, DecProcedimento metodos) {
		super(nomeAgente, metodos);
		this.baseDeRegras = baseDeRegras;
	}

	public boolean checaTipo(AmbienteCompilacaoOO1 ambiente) throws VariavelJaDeclaradaException, VariavelNaoDeclaradaException, ElementoJaDeclaradoException, ElementoNaoDeclaradoException, ProcedimentoNaoDeclaradoException, ProcedimentoJaDeclaradoException {
		ambiente.mapDefElemento(getNomeElemento(), new DefAgente(this.baseDeRegras, getMetodos()));
		boolean retorno = false;
		
		ambiente.incrementa();
		
		retorno =  baseDeRegras.checaTipo(ambiente) && getMetodos().checaTipo(ambiente);
		
		ambiente.restaura();
		
		return retorno;
	}

	public AmbienteExecucaoOO1 elabora(AmbienteExecucaoOO1 ambiente) throws VariavelJaDeclaradaException, VariavelNaoDeclaradaException, ElementoJaDeclaradoException, ElementoNaoDeclaradoException, ProcedimentoNaoDeclaradoException, ProcedimentoJaDeclaradoException {
		ambiente.mapDefElemento(getNomeElemento(), new DefAgente(this.baseDeRegras, getMetodos()));
		return ambiente;
	}

}