package plp.orientadaObjetos1.agente;

import plp.expressions2.memory.VariavelJaDeclaradaException;
import plp.expressions2.memory.VariavelNaoDeclaradaException;
import plp.orientadaObjetos1.excecao.declaracao.ElementoJaDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ElementoNaoDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ObjetoJaDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ObjetoNaoDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ProcedimentoJaDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ProcedimentoNaoDeclaradoException;
import plp.orientadaObjetos1.excecao.execucao.BaseDeRegraNaoDeclaradaException;
import plp.orientadaObjetos1.expressao.leftExpression.Id;
import plp.orientadaObjetos1.memoria.AmbienteCompilacaoOO1;
import plp.orientadaObjetos1.memoria.AmbienteExecucaoOO1;

public class DecBaseDeRegrasAtomica implements DecBaseDeRegras {
	
	private Id nomeBase;
	
	private DecRegras regras;

	public DecBaseDeRegrasAtomica(Id nomeBase, DecRegras regras) {
		this.nomeBase = nomeBase;
		this.regras = regras;
	}

	public boolean checaTipo(AmbienteCompilacaoOO1 ambiente)
			throws VariavelJaDeclaradaException, VariavelNaoDeclaradaException,
			ProcedimentoJaDeclaradoException,
			ProcedimentoNaoDeclaradoException, ElementoJaDeclaradoException,
			ElementoNaoDeclaradoException {
		
		return regras.checaTipo(ambiente);
	}

	public AmbienteExecucaoOO1 elabora(AmbienteExecucaoOO1 ambiente)
			throws VariavelJaDeclaradaException, VariavelNaoDeclaradaException,
			ProcedimentoJaDeclaradoException,
			ProcedimentoNaoDeclaradoException, ElementoJaDeclaradoException,
			ElementoNaoDeclaradoException, ObjetoNaoDeclaradoException,
			ObjetoJaDeclaradoException {
		// TODO Auto-generated method stub
		return null;
	}

	public BaseDeRegras getBaseDeRegras(Id baseDeRegras) throws BaseDeRegraNaoDeclaradaException {
		if (this.nomeBase.equals(baseDeRegras)) {
			return new BaseDeRegras(nomeBase, regras);
		} else {
			throw new BaseDeRegraNaoDeclaradaException(baseDeRegras);
		}
		
	}

}