package plp.orientadaObjetos1.comando;

import plp.expressions2.memory.VariavelJaDeclaradaException;
import plp.expressions2.memory.VariavelNaoDeclaradaException;
import plp.orientadaObjetos1.excecao.declaracao.ElementoJaDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ElementoNaoDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ObjetoJaDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ObjetoNaoDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ProcedimentoJaDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ProcedimentoNaoDeclaradoException;
import plp.orientadaObjetos1.excecao.execucao.BaseDeRegraNaoDeclaradaException;
import plp.orientadaObjetos1.excecao.execucao.CondicaoInvalidadaException;
import plp.orientadaObjetos1.excecao.execucao.EntradaInvalidaException;
import plp.orientadaObjetos1.expressao.leftExpression.Id;
import plp.orientadaObjetos1.expressao.valor.Valor;
import plp.orientadaObjetos1.expressao.valor.ValorRef;
import plp.orientadaObjetos1.memoria.AmbienteCompilacaoOO1;
import plp.orientadaObjetos1.memoria.AmbienteExecucaoOO1;
import plp.orientadaObjetos1.memoria.Objeto;
import plp.orientadaObjetos1.util.TipoElemento;

public abstract class ComandoAgente implements Comando {

	private Id nomeAgente; // nome do objeto agente

	private Id objeto;

	public ComandoAgente(Id nomeBase, Id objeto) {
		this.nomeAgente = nomeBase;
		this.objeto = objeto;
	}

	public boolean checaTipo(AmbienteCompilacaoOO1 ambiente)
			throws VariavelNaoDeclaradaException, VariavelJaDeclaradaException,
			ProcedimentoNaoDeclaradoException,
			ProcedimentoJaDeclaradoException, ElementoJaDeclaradoException,
			ElementoNaoDeclaradoException {

		try {
			TipoElemento tipo = (TipoElemento) ambiente.get(nomeAgente);
			return tipo != null && tipo.isAgente();
		} catch (ClassCastException ex) {
			// TODO Add a exception
			throw new RuntimeException(nomeAgente.getIdName());
		}
	}

	public abstract AmbienteExecucaoOO1 executar(AmbienteExecucaoOO1 ambiente)
			throws VariavelJaDeclaradaException, VariavelNaoDeclaradaException,
			ObjetoJaDeclaradoException, ObjetoNaoDeclaradoException,
			ProcedimentoNaoDeclaradoException,
			ProcedimentoJaDeclaradoException, ElementoJaDeclaradoException,
			ElementoNaoDeclaradoException, EntradaInvalidaException, BaseDeRegraNaoDeclaradaException, CondicaoInvalidadaException;

	public Id getNomeAgente() {
		return nomeAgente;
	}

	public Id getObjeto() {
		return objeto;
	}

	public Objeto getObjetoPorId(AmbienteExecucaoOO1 ambiente,
			Id nomeVariavel) throws ObjetoNaoDeclaradoException,
			ElementoNaoDeclaradoException {
		
		try {
			Valor v = ambiente.getPilha().peek().get(nomeVariavel);
			Objeto obj = ambiente.getObjeto((ValorRef) v);
			return obj;
		} catch (Exception ex) {
			throw new ObjetoNaoDeclaradoException(nomeVariavel);
		}
				
	}

}
