package plp.orientadaObjetos1.comando;

import plp.expressions2.memory.VariavelJaDeclaradaException;
import plp.expressions2.memory.VariavelNaoDeclaradaException;
import plp.orientadaObjetos1.excecao.declaracao.ElementoJaDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ElementoNaoDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ObjetoJaDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ObjetoNaoDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ProcedimentoJaDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ProcedimentoNaoDeclaradoException;
import plp.orientadaObjetos1.excecao.execucao.EntradaInvalidaException;
import plp.orientadaObjetos1.expressao.leftExpression.Id;
import plp.orientadaObjetos1.expressao.valor.ValorRef;
import plp.orientadaObjetos1.memoria.AmbienteExecucaoOO1;
import plp.orientadaObjetos1.memoria.DefAgente;
import plp.orientadaObjetos1.memoria.DefElemento;
import plp.orientadaObjetos1.memoria.Objeto;

public class ComandoInserir extends ComandoAgente {

	public ComandoInserir(Id nomeAgente, Id objeto) {
		super(nomeAgente, objeto);
	}

	@Override
	public AmbienteExecucaoOO1 executar(AmbienteExecucaoOO1 ambiente)
			throws VariavelJaDeclaradaException, VariavelNaoDeclaradaException,
			ObjetoJaDeclaradoException, ObjetoNaoDeclaradoException,
			ProcedimentoNaoDeclaradoException,
			ProcedimentoJaDeclaradoException, ElementoJaDeclaradoException,
			ElementoNaoDeclaradoException, EntradaInvalidaException {

		ValorRef refObjeto = (ValorRef) ambiente.get(getObjeto());
		ValorRef refAgente = (ValorRef) ambiente.get(getNomeAgente());
		Objeto objeto = ambiente.getObjeto(refAgente);
		DefElemento defElemento = ambiente.getDefElemento(objeto.getClasse());

		if (defElemento != null && defElemento instanceof DefAgente && refObjeto != null) {
			DefAgente defAgente = (DefAgente) defElemento; 
			defAgente.adicionar(refObjeto);

		} else {
			throw new ObjetoNaoDeclaradoException(getNomeAgente());
		}

		return ambiente;
	}
	
	

}
