package plp.orientadaObjetos1.comando;

import plp.expressions2.memory.VariavelJaDeclaradaException;
import plp.expressions2.memory.VariavelNaoDeclaradaException;
import plp.orientadaObjetos1.excecao.execucao.EntradaInvalidaException;
import plp.orientadaObjetos1.expressao.leftExpression.Id;
import plp.orientadaObjetos1.memoria.AmbienteCompilacaoOO1;
import plp.orientadaObjetos1.memoria.AmbienteExecucaoOO1;
import plp.orientadaObjetos1.util.Tipo;

/**
 * Representa um comando de leitura.
 */
public class Read implements IO{
	/**
	 * O identificador ao qual ser atribudo o valor lido.
	 */
    private Id id;
	/**
	 * O tipo do identificador cujo novo valor ser lido.
	 */
    private Tipo tipoId;
	/**
	 * Construtor.
	 * @param id O identificador ao qual ser a atribudo o valor lido.
	 */
    public Read ( Id id){
        this.id = id;
    }

    /**
     * L da entrada padro.
     * @param ambiente o ambiente de execuo.
     * @return o ambiente depois de modificado pela execuo
     * do comando read.
     *
     */
    public AmbienteExecucaoOO1 executar(AmbienteExecucaoOO1 ambiente)
        throws VariavelJaDeclaradaException, VariavelNaoDeclaradaException, EntradaInvalidaException {
        ambiente.changeValor(id, ambiente.read(this.tipoId));
        return ambiente;
    }

    /**
     * Realiza a verificacao de tipos da entrada
     * @param ambiente o ambiente de compilao.
     * @return <code>true</code> se a expresso da entrada est bem tipada;
     *          <code>false</code> caso contrario.
     */
    public boolean checaTipo(AmbienteCompilacaoOO1 ambiente)
        throws VariavelNaoDeclaradaException {
//      Alteramos a implementao, pois em tempo de compilao no se pode saber
//      o tipo da entrada que ser lida.

//        Tipo tipo = ambiente.getTipoEntrada();
//        Tipo tipo2 = id.getTipo(ambiente);

        this.tipoId = id.getTipo(ambiente);
        return id.checaTipo(ambiente);

        //return id.getTipo(ambiente).equals(ambiente.getTipoEntrada());
    }

}
