package plp.orientadaObjetos1.declaracao.elemento;

import plp.expressions2.memory.VariavelJaDeclaradaException;
import plp.expressions2.memory.VariavelNaoDeclaradaException;
import plp.orientadaObjetos1.declaracao.procedimento.DecProcedimento;
import plp.orientadaObjetos1.excecao.declaracao.ElementoJaDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ElementoNaoDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ProcedimentoJaDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ProcedimentoNaoDeclaradoException;
import plp.orientadaObjetos1.expressao.leftExpression.Id;
import plp.orientadaObjetos1.memoria.AmbienteCompilacaoOO1;
import plp.orientadaObjetos1.memoria.AmbienteExecucaoOO1;

public abstract class DecElementoSimples implements DecElemento {

	/**
	 * Identificador do nome da classe.
	 */
	private Id nomeElemento;

	/**
	 * Mtodos da classe.
	 */
	private DecProcedimento metodos;

	public DecElementoSimples(Id nomeClasse, DecProcedimento metodos) {
		this.nomeElemento = nomeClasse;
		this.metodos = metodos;
	}

	public DecProcedimento getMetodos() {
		return metodos;
	}

	public Id getNomeElemento() {
		return nomeElemento;
	}

	/**
	 * Cria um mapeamento do identificador para o valor da expresso desta
	 * declarao no AmbienteExecucao
	 * 
	 * @param ambiente
	 *            o ambiente que contem o mapeamento entre identificadores e
	 *            valores.
	 * @return o ambiente modificado pela inicializao da varivel.
	 */
	public abstract AmbienteExecucaoOO1 elabora(AmbienteExecucaoOO1 ambiente)
			throws VariavelJaDeclaradaException, VariavelNaoDeclaradaException,
			ElementoJaDeclaradoException, ElementoNaoDeclaradoException,
			ProcedimentoNaoDeclaradoException, ProcedimentoJaDeclaradoException;

	/**
	 * Verifica se a declarao est bem tipada, ou seja, se a expresso de
	 * inicializao est bem tipada.
	 * 
	 * @param ambiente
	 *            o ambiente que contem o mapeamento entre identificadores e
	 *            seus tipos.
	 * @return <code>true</code> se os tipos da declarao so vlidos;
	 *         <code>false</code> caso contrario.
	 */
	public abstract boolean checaTipo(AmbienteCompilacaoOO1 ambiente)
			throws VariavelJaDeclaradaException, VariavelNaoDeclaradaException,
			ElementoJaDeclaradoException, ElementoNaoDeclaradoException,
			ProcedimentoNaoDeclaradoException, ProcedimentoJaDeclaradoException;

}
