package plp.orientadaObjetos1.declaracao.variavel;

import plp.expressions2.memory.VariavelJaDeclaradaException;
import plp.expressions2.memory.VariavelNaoDeclaradaException;
import plp.orientadaObjetos1.declaracao.Declaracao;
import plp.orientadaObjetos1.excecao.declaracao.ElementoJaDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ElementoNaoDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ObjetoJaDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ObjetoNaoDeclaradoException;
import plp.orientadaObjetos1.expressao.leftExpression.Id;
import plp.orientadaObjetos1.memoria.AmbienteCompilacaoOO1;
import plp.orientadaObjetos1.memoria.AmbienteExecucaoOO1;
import plp.orientadaObjetos1.util.Tipo;

/**
 * Interface representando uma declarao de varivel.
 */
public interface DecVariavel extends Declaracao {

    /**
     * Retorna o tipo do identificador a ser declarado no AmbienteCompilacao
     * @param id o identificador  da declaracao
     * @return o tipo do identificador
     */
    public Tipo getTipo(Id id)
        throws VariavelNaoDeclaradaException ;

    /**
     * Cria um mapeamento do identificador para o valor da expresso
     * desta declarao no AmbienteExecucao
     * @param ambiente o ambiente que contem o mapeamento entre identificadores
     *  e valores.
     * @return o ambiente modificado pela inicializao da varivel.
     */
    public AmbienteExecucaoOO1 elabora(AmbienteExecucaoOO1 ambiente)
        throws VariavelJaDeclaradaException, VariavelNaoDeclaradaException,
               ElementoJaDeclaradoException, ElementoNaoDeclaradoException,
               ObjetoNaoDeclaradoException, ObjetoJaDeclaradoException ;

    /**
     * Verifica se a declarao est bem tipada, ou seja, se a
     * expresso de inicializao est bem tipada.
     * @param ambiente o ambiente que contem o mapeamento entre identificadores
     *  e seus tipos.
     * @return <code>true</code> se os tipos da declarao so vlidos;
     *          <code>false</code> caso contrario.
     */
    public boolean checaTipo(AmbienteCompilacaoOO1 ambiente)
        throws VariavelNaoDeclaradaException, VariavelJaDeclaradaException,
               ElementoJaDeclaradoException, ElementoNaoDeclaradoException;
}
