package plp.orientadaObjetos1.memoria;

import plp.expressions2.expression.Id;
import plp.expressions2.memory.VariavelNaoDeclaradaException;
import plp.orientadaObjetos1.declaracao.procedimento.ListaDeclaracaoParametro;
import plp.orientadaObjetos1.excecao.declaracao.ProcedimentoJaDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ProcedimentoNaoDeclaradoException;
import plp.orientadaObjetos1.util.Tipo;
/**
 * Classe que representa o ambiente de compilao, contendo o mapeamento
 * entre identificadores e tipos.
 */
public interface AmbienteCompilacaoOO1 extends AmbienteOO1<Tipo> {

    /**
     * Mapeia um identificador representando um mtodo aos seus parmetros.
     * @param idArg identificador do mtodo.
     * @param parametrosId Parmetros do mtodo
     * @throws ProcedimentoJaDeclaradoException quando o procedimento j foi
     * declarado.
     */
    public void mapParametrosProcedimento(Id idArg, ListaDeclaracaoParametro parametrosId) throws ProcedimentoJaDeclaradoException;

    /**
     * Obtm a tail de parmetros associada a um identificador que representa
     * nome do mtodo.
     * @param idArg Identificador que representa o nome do mtodo.
     * @return Lista de parmetros Lista de parmetros associada a um identificador que representa
     * nome do mtodo.
     * @throws ProcedimentoNaoDeclaradoException quando no foi declarado nenhum
     * mtodo com esse id.
     */
    public ListaDeclaracaoParametro getParametrosProcedimento(Id idArg) throws ProcedimentoNaoDeclaradoException;

    /**
     * Obtm o tipo da entrada atual para este ambiente.
     * @return o tipo da entrada.
     * @throws VariavelNaoDeclaradaException quando a entrada atual 
     * uma varivel no declarada.
     */
    public Tipo getTipoEntrada() throws VariavelNaoDeclaradaException;

}
