package plp.orientadaObjetos1.memoria;

import plp.expressions2.expression.Id;
import plp.expressions2.memory.Ambiente;
import plp.orientadaObjetos1.excecao.declaracao.ElementoJaDeclaradoException;
import plp.orientadaObjetos1.excecao.declaracao.ElementoNaoDeclaradoException;

/**
 * Interface que representa um ambiente.
 */
public interface AmbienteOO1<T> extends Ambiente<T>{
	
	/**
	 * Mapeia um identificador a um definio de classe.
	 * 
	 * @param idArg
	 *            o nome da classe
	 * @param defClasse
	 *            Definio da Classe.
	 * @throws ElementoJaDeclaradoException
	 *             quando a classe j foi declarada.
	 */
	public void mapDefElemento(Id idArg, DefElemento defClasse)
			throws ElementoJaDeclaradoException;

	/**
	 * Obtm a definio da classe cujo nome  idArg
	 * 
	 * @param idArg
	 *            Nome da classe.
	 * @return a definio da classe.
	 * @throws ElementoNaoDeclaradoException
	 *             quando nao foi declarada nenhuma classe com esse nome.
	 */
	public DefElemento getDefElemento(Id idArg) throws ElementoNaoDeclaradoException;
	
	
}