package plp.orientadaObjetos1.memoria;

import java.util.ArrayList;
import java.util.List;

import plp.orientadaObjetos1.agente.BaseDeRegras;
import plp.orientadaObjetos1.agente.DecBaseDeRegras;
import plp.orientadaObjetos1.declaracao.procedimento.DecProcedimento;
import plp.orientadaObjetos1.excecao.execucao.BaseDeRegraNaoDeclaradaException;
import plp.orientadaObjetos1.expressao.leftExpression.Id;
import plp.orientadaObjetos1.expressao.valor.ValorRef;

public class DefAgente extends DefElemento {
	
	private DecBaseDeRegras decBaseDeRegras;
	
	private List<ValorRef> fatos;

	public DefAgente(DecBaseDeRegras decBaseDeRegras, DecProcedimento decProcedimento) {
		super(decProcedimento);
		this.decBaseDeRegras = decBaseDeRegras;
		this.fatos = new ArrayList<ValorRef>();
	}

	public BaseDeRegras getBaseDeRegras(Id baseDeRegras) throws BaseDeRegraNaoDeclaradaException {
		return decBaseDeRegras.getBaseDeRegras(baseDeRegras);
	}
	
	public void adicionar(ValorRef fato) {
		this.fatos.add(fato);
	}
	
	public void remover(ValorRef fato) {
		this.fatos.remove(fato);
	}
	
	public void atualizar(ValorRef fato) {
		int i = this.fatos.indexOf(fato);
		
		if (i != -1) {
			this.fatos.set(i, fato);
		}
	}

	public List<ValorRef> getFatos() {
		return fatos;
	}

}
