package plp.orientadaObjetos1.memoria;

import plp.expressions2.memory.VariavelNaoDeclaradaException;
import plp.orientadaObjetos1.declaracao.procedimento.DecProcedimento;
import plp.orientadaObjetos1.declaracao.variavel.DecVariavel;
import plp.orientadaObjetos1.expressao.leftExpression.Id;
import plp.orientadaObjetos1.util.Tipo;

/**
 * Uma definiao de classe  uma declaraao de varivel e
 * uma declarao de procedimento. Ambos podem ser simples ou compostos.
 */
public class DefClasse extends DefElemento {
    /**
     * Declarao de varivel
     */
    private DecVariavel decVariavel;

    /**
     * Construtor
     * @param decVariavel Declarao de Variveis
     * @param decProcedimento Declaraao dos Procedimentos.
     */
    public DefClasse(DecVariavel decVariavel, DecProcedimento decProcedimento) {
    	super(decProcedimento);
        this.decVariavel = decVariavel;        
    }
    /**
     * Obtm as declaraoes das variveis.
     * @return as declaraoes das variveis.
     */
    public DecVariavel getDecVariavel(){
        return decVariavel;
    }
    
    /**
     * O mtodo abaixo deve verificar se existe algum atributo, identificado por idAtributo
     * na definicao da classe
     * @param idAtributo Um identificador de atributo.
     * @param Tipo O tipo do atributo do identificador.
     */
    public Tipo getTipoAtributo(Id idAtributo)throws VariavelNaoDeclaradaException{
        return decVariavel.getTipo(idAtributo);
    }
}
