package plp.orientadaObjetos1.memoria;

import plp.orientadaObjetos1.comando.Procedimento;
import plp.orientadaObjetos1.declaracao.procedimento.DecProcedimento;
import plp.orientadaObjetos1.excecao.declaracao.ProcedimentoNaoDeclaradoException;
import plp.orientadaObjetos1.expressao.leftExpression.Id;

public abstract class DefElemento {
	/**
     * Declaraao do Procedimento
     */
    private DecProcedimento decProcedimento;

	public DefElemento(DecProcedimento decProcedimento) {
		super();
		this.decProcedimento = decProcedimento;
	}

	protected DecProcedimento getDecProcedimento() {
		return decProcedimento;
	}
	
	/**
     * Retorna um mtodo da classe a partir de seu identificador.
     * @param idMetodo Identificador do mtodo
     * @return o mtodo desejado
     * @throws ProcedimentoNaoDeclaradoException
     */
    public Procedimento getMetodo(Id idMetodo)throws ProcedimentoNaoDeclaradoException{
        return decProcedimento.getProcedimento(idMetodo);
    }

}
