package plp.orientadaObjetos1.util;

import plp.orientadaObjetos1.excecao.declaracao.ElementoNaoDeclaradoException;
import plp.orientadaObjetos1.expressao.leftExpression.Id;
import plp.orientadaObjetos1.memoria.AmbienteCompilacaoOO1;
/**
 * Interface  representando um tipo.
 */
public interface Tipo {
    /**
     * Obtm o tipo, representado por um identficador.
     * @return o tipo
     */
    public Id getTipo();
    /**
     * Compara dois tipos.
     * @param obj O objeto a ser comparado com este tipo.
     * @return true, se o obj  igual a este tipo, false, caso contrrio.
     */
    public boolean equals(Object obj);
    /**
     * Verifica se o tipo  vlido no ambiente.
     * @param ambiente o ambiente de compilaao, que apresenta o mapeamento
     * entre identificadores e tipos.
     * @return true, se o tipo for vlido no ambiente, false, caso contrrio.
     * @throws ElementoNaoDeclaradoException
     */
    public boolean eValido(AmbienteCompilacaoOO1 ambiente) throws ElementoNaoDeclaradoException;
}
